------------------------------------------------------------------------
-- Rocket
------------------------------------------------------------------------
function initArray(m)
local array = {}
for i = 1, m do
array[i]=0
end
return array
end

cs_rocket_sec=initArray(32)
cs_rocket_boom=initArray(32)
cs_rocket_trigger=initArray(32)
cs_rocket_button=initArray(32)

cs_rocket_x=initArray(32)
cs_rocket_y=initArray(32)

	
-- SV_SOUND3
function sv_sound3(x,y,sound)
for _, id in pairs(player(0,"table")) do
if x and y and sound then
if math.sqrt((x-player(id,"x"))^2 + (y-player(id,"y"))^2) < 300 then
parse("sv_sound2 "..id.." "..sound)
end; end; end
end

------------------------------------------------------------------------


------------------------------------------------------------------
-- SPAWN Function
------------------------------------------------------------------
addhook("spawn","cs_rocket_spawn")
function cs_rocket_spawn(id)
cs_rocket_sec[id]=-1
cs_rocket_boom[id]=-1
cs_rocket_trigger[id]=0
cs_rocket_button[id]=0

cs_rocket_x[id]=player(id,"x")
cs_rocket_y[id]=player(id,"y")

end


------------------------------------------------------------------
-- DIE Function
------------------------------------------------------------------
addhook("die","cs_rocket_die")
function cs_rocket_die(id)

cs_rocket_sec[id]=-1
cs_rocket_boom[id]=-1
cs_rocket_trigger[id]=0
cs_rocket_button[id]=0
end


------------------------------------------------------------------
-- MOVE Function
------------------------------------------------------------------
addhook("move","cs_rocket_move")
function cs_rocket_move(id)

cs_rocket_x[id]=player(id,"x")
cs_rocket_y[id]=player(id,"y")

end


------------------------------------------------------------------
-- SAY Function
------------------------------------------------------------------
addhook("say","cs_rocket_say")
function cs_rocket_say(id,txt)


if (txt=="rocket") or (txt=="ROCKET") then
if player(id,"health")>0 then
if cs_rocket_button[id]==0 then
cs_rocket_x[id]=player(id,"x")
cs_rocket_y[id]=player(id,"y")
parse("speedmod "..id.." -100") 
parse('effect "colorsmoke" ' .. player(id, "x") .. ' ' .. player(id, "y") .. ' 50 50 128 128 128')
sv_sound3(player(id,"x"),player(id,"y"),"env/zrocket_start.ogg")
cs_rocket_sec[id]=20
cs_rocket_button[id]=1
end; end; end
end

addhook("sayteam","cs_rocket_sayteam")
function cs_rocket_sayteam(id,txt)

if (txt=="rocket") or (txt=="ROCKET") then
if player(id,"health")>0 then
if cs_rocket_button[id]==0 then
cs_rocket_x[id]=player(id,"x")
cs_rocket_y[id]=player(id,"y")
parse("speedmod "..id.." -100") 
parse('effect "colorsmoke" ' .. player(id, "x") .. ' ' .. player(id, "y") .. ' 50 50 128 128 128')
sv_sound3(player(id,"x"),player(id,"y"),"env/zrocket_start.ogg")
cs_rocket_sec[id]=20
cs_rocket_button[id]=1
end; end; end
end


------------------------------------------------------------------
-- MS100 Function
------------------------------------------------------------------
addhook("ms100","cs_rocket_ms100")
function cs_rocket_ms100()

for i=1,32 do

cs_rocket_sec[i]=cs_rocket_sec[i]-1
cs_rocket_boom[i]=cs_rocket_boom[i]-1

if cs_rocket_sec[i]==0 then
cs_rocket_trigger[i]=1
cs_rocket_boom[i]=20
sv_sound3(player(i,"x"),player(i,"y"),"env/zrocket_end.ogg")
end


if cs_rocket_boom[i]==0 then
parse("killplayer "..i)
parse("explosion "..cs_rocket_x[i].." "..cs_rocket_y[i].." 150 0 "..i)
end

if cs_rocket_button[i]==1 then
parse("shake "..i.." 5")
end

if cs_rocket_trigger[i]==1 then

if cs_rocket_boom[i]==19 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==17 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==15 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==12 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==10 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==7 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==5 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==3 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
elseif cs_rocket_boom[i]==1 then
parse('effect "fire" ' .. player(i, "x") .. ' ' .. player(i, "y") .. ' 0 10 000 000 000')
end

end
end

end


------------------------------------------------------------------
-- ALWAYS Function
------------------------------------------------------------------
addhook("always","cs_rocket_always")
function cs_rocket_always()

for i=1,32 do

if cs_rocket_trigger[i]==1 then
cs_rocket_y[i]=cs_rocket_y[i]-5
parse("setpos "..i.." "..cs_rocket_x[i].." "..cs_rocket_y[i])
parse("setweapon "..i.." 50")
end

end
end

